﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using MvvmExample.Helpers;
using System.Data;
using System.Windows.Input;

namespace MvvmExample.ViewModel
{
    class ViewModelMain : ViewModelBase
    {


        //private RelayCommand BtnSaveRecipe = default(RelayCommand);
        //public ICommand btnSaveRecipe
        //{
        //    get
        //    {
        //        if (BtnSaveRecipe == null)
        //        {
        //            BtnSaveRecipe =  new RelayCommand(
        //                             () => this.SaveRecipeDetails());
        //        }
        //        return this.BtnSaveRecipe;
        //    }
          
        //}

       public  ViewModelMain()
        {
            CallFunction();
            AddUserCommand = new RelayCommand(o => { SaveRecipeDetails(); }); 
        }

        public RelayCommand AddUserCommand { get; set; } 

      public void SaveRecipeDetails()
        {

            System.Threading.Thread.Sleep((int)System.TimeSpan.FromSeconds(10).TotalMilliseconds);
            foreach (DataTable dt in Dataset.Tables)
            {
                int current_selected_version = 0;
                DataTable final_table = new DataTable();
                DataTable SelectedTable = new DataTable();
                int parama_version_count = 0;
                final_table = dt.Clone();
                final_table.Rows.Clear();
                foreach (DataRow row in dt.Rows)
                {
                    current_selected_version++;
                    parama_version_count++;
                    if ((bool)(row["SELECT_VERSION"]) == true)
                    {
                        SelectedTable = (DataTable)row["PARAMETER_DETAILS"];
                        break;
                    }
                }

                for (int rowIndex = 0; rowIndex < dt.Rows.Count; rowIndex++)
                {
                    dt.Rows[rowIndex][2] = SelectedTable;
                }
                for (int rowIndex = 0; rowIndex < dt.Rows.Count; rowIndex++)
                {
                    if ((rowIndex + 1) == current_selected_version)
                    {
                        dt.Rows[rowIndex][4] = dt.Rows[rowIndex][0];
                        continue;
                    }
                    //MainRecipeData.Rows[rowIndex][3] = current_selected_version;
                    int current_version = (int)dt.Rows[rowIndex][0];
                    dt.Rows[rowIndex][4] = current_version + dt.Rows.Count; ;
                }




            }


            ShowSaveMessage = true;
        }


          

        private bool showsavemessage = false;
        public bool ShowSaveMessage
        {
            get { return showsavemessage; }
            set
            {
                showsavemessage = value;
                RaisePropertyChanged("ShowSaveMessage");
            }
        }

          private string successmessage = "Selected this parameter  version for the recipe";
        public string SuccessMessage
        {
            get { return successmessage; }
            set { successmessage = value; }
        }
      

        //private RelayCommand BtnDisplayRecipe = default(RelayCommand);
        //public ICommand btnDisplayRecipe
        //{
        //    get
        //    {
        //        if (BtnDisplayRecipe == null)
        //        {
        //            BtnDisplayRecipe = new RelayCommand(
        //                             () => this.CallFunction());
        //        }
        //        return this.BtnDisplayRecipe;
        //    }
        //}

        private DataTable recipedata = null;
        public DataTable MainRecipeData
        {
            get { return recipedata; }
            set { recipedata = value;
           RaisePropertyChanged("MainRecipeData");
            }
        }


        private DataSet dataset = null;
        public DataSet Dataset
        {
            get { return dataset; }
            set
            {
                dataset = value;
                RaisePropertyChanged("Dataset");
            }
        }
        public void CallFunction()
        {
            DataTable table = new DataTable();
            table.Columns.Add("Parameter Name");
            table.Columns.Add("Parameter Value");

            DataRow dt = null;
            dt = table.NewRow();
            dt["Parameter Name"] = "WBB_SITTIME";
            dt["Parameter Value"] = "12";
            table.Rows.Add(dt);
            dt = table.NewRow();
            dt["Parameter Name"] = "Window_Clamp";
            dt["Parameter Value"] = "Trigger";
            table.Rows.Add(dt);
            dt = table.NewRow();
            dt["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt["Parameter Value"] = "15";
            table.Rows.Add(dt);


            DataTable table1 = new DataTable();
            table1.Columns.Add("Parameter Name");
            table1.Columns.Add("Parameter Value");

            DataRow dt1 = null;
            dt1 = table1.NewRow();
            dt1["Parameter Name"] = "WBB_SITTIME";
            dt1["Parameter Value"] = "21";
            table1.Rows.Add(dt1);
            dt1 = table1.NewRow();
            dt1["Parameter Name"] = "Window_Clamp";
            dt1["Parameter Value"] = "Trigger";
            table1.Rows.Add(dt1);
            dt1 = table1.NewRow();
            dt1["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt1["Parameter Value"] = "23";
            table1.Rows.Add(dt1);

            DataTable table2 = new DataTable();
            table2.Columns.Add("Parameter Name");
            table2.Columns.Add("Parameter Value");

            DataRow dt2 = null;
            dt2 = table2.NewRow();
            dt2["Parameter Name"] = "WBB_SITTIME";
            dt2["Parameter Value"] = "24";
            table2.Rows.Add(dt2);
            dt2 = table2.NewRow();
            dt2["Parameter Name"] = "Window_Clamp";
            dt2["Parameter Value"] = "SAMPLE";
            table2.Rows.Add(dt2);
            dt2 = table2.NewRow();
            dt2["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt2["Parameter Value"] = "445";
            table2.Rows.Add(dt2);

            DataTable table3 = new DataTable();
            table3.Columns.Add("Parameter Name");
            table3.Columns.Add("Parameter Value");

            DataRow dt3 = null;
            dt3 = table3.NewRow();
            dt3["Parameter Name"] = "WBB_SITTIME";
            dt3["Parameter Value"] = "34";
            table3.Rows.Add(dt3);
            dt3 = table3.NewRow();
            dt3["Parameter Name"] = "Window_Clamp";
            dt3["Parameter Value"] = "TRIGGER";
            table3.Rows.Add(dt3);
            dt3 = table3.NewRow();
            dt3["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt3["Parameter Value"] = "4450";
            table3.Rows.Add(dt3);


            DataTable table4 = new DataTable();
            table4.Columns.Add("Parameter Name");
            table4.Columns.Add("Parameter Value");

            DataRow dt4 = null;
            dt4 = table4.NewRow();
            dt4["Parameter Name"] = "WBB_SITTIME";
            dt4["Parameter Value"] = "25";
            table4.Rows.Add(dt4);
            dt4 = table4.NewRow();
            dt4["Parameter Name"] = "Window_Clamp";
            dt4["Parameter Value"] = "ACTION_TABLE";
            table4.Rows.Add(dt4);
            dt4 = table4.NewRow();
            dt4["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt4["Parameter Value"] = "2554";
            table4.Rows.Add(dt4);


            DataTable RecipeData = new DataTable("OPERATION: 1928, PRODUCT GROUP:XG748 SAMSUNG");
            DataColumn Ver_Col = RecipeData.Columns.Add("CURRENT_RECIPE_VERSION", typeof(Int32));
            DataColumn Ent_Col = RecipeData.Columns.Add("ENTITY/LINK", typeof(string));
            DataColumn Tbl_col = RecipeData.Columns.Add("PARAMETER_DETAILS", typeof(DataTable));
            DataColumn Selected_row = RecipeData.Columns.Add("SELECT_VERSION", typeof(bool));
            DataColumn Current_version = RecipeData.Columns.Add("NEW_RECIPE_VERSION", typeof(Int32));

            DataRow First_version = null;
            First_version = RecipeData.NewRow();
            First_version["CURRENT_RECIPE_VERSION"] = 1;
            First_version["ENTITY/LINK"] = "A04_KWB401";
            First_version["PARAMETER_DETAILS"] = table1;
            First_version["SELECT_VERSION"] = false;
            First_version["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData.Rows.Add(First_version);

            DataRow Second_version = null;
            Second_version = RecipeData.NewRow();
            Second_version["CURRENT_RECIPE_VERSION"] = 2;
            Second_version["ENTITY/LINK"] = "A04_KWB402";
            Second_version["PARAMETER_DETAILS"] = table2;
            Second_version["SELECT_VERSION"] = false;
            Second_version["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData.Rows.Add(Second_version);


            DataRow Third_Version = null;
            Third_Version = RecipeData.NewRow();
            Third_Version["CURRENT_RECIPE_VERSION"] = 3;
            Third_Version["ENTITY/LINK"] = "A04_KWB403";
            Third_Version["PARAMETER_DETAILS"] = table3;
            Third_Version["SELECT_VERSION"] = false;
            Third_Version["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData.Rows.Add(Third_Version);

            DataRow Fourth_Version = null;
            Fourth_Version = RecipeData.NewRow();
            Fourth_Version["CURRENT_RECIPE_VERSION"] = 4;
            Fourth_Version["ENTITY/LINK"] = "A04_KWB404";
            Fourth_Version["PARAMETER_DETAILS"] = table4;
            Fourth_Version["SELECT_VERSION"] = false;
            Fourth_Version["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData.Rows.Add(Fourth_Version);

            MainRecipeData = RecipeData;

            DataTable table5 = new DataTable();
            table5.Columns.Add("Parameter Name");
            table5.Columns.Add("Parameter Value");

            DataRow dt5 = null;
            dt5 = table5.NewRow();
            dt5["Parameter Name"] = "WBB_SITTIME";
            dt5["Parameter Value"] = "12";
            table5.Rows.Add(dt5);
            dt5 = table5.NewRow();
            dt5["Parameter Name"] = "Window_Clamp";
            dt5["Parameter Value"] = "Trigger";
            table5.Rows.Add(dt5);
            dt5 = table5.NewRow();
            dt5["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt5["Parameter Value"] = "15";
            table5.Rows.Add(dt5);


            DataTable table6 = new DataTable();
            table6.Columns.Add("Parameter Name");
            table6.Columns.Add("Parameter Value");

            DataRow dt6 = null;
            dt6 = table6.NewRow();
            dt6["Parameter Name"] = "WBB_SITTIME";
            dt6["Parameter Value"] = "21";
            table6.Rows.Add(dt6);
            dt6 = table6.NewRow();
            dt6["Parameter Name"] = "Window_Clamp";
            dt6["Parameter Value"] = "Trigger";
            table6.Rows.Add(dt6);
            dt6 = table6.NewRow();
            dt6["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt6["Parameter Value"] = "23";
            table6.Rows.Add(dt6);

            DataTable table7 = new DataTable();
            table7.Columns.Add("Parameter Name");
            table7.Columns.Add("Parameter Value");

            DataRow dt7 = null;
            dt7 = table7.NewRow();
            dt7["Parameter Name"] = "WBB_SITTIME";
            dt7["Parameter Value"] = "24";
            table7.Rows.Add(dt7);
            dt7 = table7.NewRow();
            dt7["Parameter Name"] = "Window_Clamp";
            dt7["Parameter Value"] = "SAMPLE";
            table7.Rows.Add(dt7);
            dt7 = table7.NewRow();
            dt7["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt7["Parameter Value"] = "445";
            table7.Rows.Add(dt7);

            DataTable table8 = new DataTable();
            table8.Columns.Add("Parameter Name");
            table8.Columns.Add("Parameter Value");

            DataRow dt8 = null;
            dt8 = table8.NewRow();
            dt8["Parameter Name"] = "WBB_SITTIME";
            dt8["Parameter Value"] = "34";
            table8.Rows.Add(dt8);
            dt8 = table8.NewRow();
            dt8["Parameter Name"] = "Window_Clamp";
            dt8["Parameter Value"] = "TRIGGER";
            table8.Rows.Add(dt8);
            dt8 = table8.NewRow();
            dt8["Parameter Name"] = "DAGE_PRE_LOT_TEST_PLAN";
            dt8["Parameter Value"] = "4450";
            table8.Rows.Add(dt8);


          


            DataTable RecipeData2 = new DataTable("OPERATION: 1928, PRODUCT GROUP:XG756 SAMSUNG DRAM Val");
            DataColumn Ver_Col2 = RecipeData2.Columns.Add("CURRENT_RECIPE_VERSION", typeof(Int32));
            DataColumn Ent_Col2 = RecipeData2.Columns.Add("ENTITY/LINK", typeof(string));
            DataColumn Tbl_col2 = RecipeData2.Columns.Add("PARAMETER_DETAILS", typeof(DataTable));
            DataColumn Selected_row2 = RecipeData2.Columns.Add("SELECT_VERSION", typeof(bool));
            DataColumn Current_version2 = RecipeData2.Columns.Add("NEW_RECIPE_VERSION", typeof(Int32));

            DataRow First_version1 = null;
            First_version1 = RecipeData2.NewRow();
            First_version1["CURRENT_RECIPE_VERSION"] = 1;
            First_version1["ENTITY/LINK"] = "A04_KWB401";
            First_version1["PARAMETER_DETAILS"] = table5;
            First_version1["SELECT_VERSION"] = false;
            First_version1["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData2.Rows.Add(First_version1);

            DataRow Second_version1 = null;
            Second_version1 = RecipeData2.NewRow();
            Second_version1["CURRENT_RECIPE_VERSION"] = 2;
            Second_version1["ENTITY/LINK"] = "A04_KWB402";
            Second_version1["PARAMETER_DETAILS"] = table6;
            Second_version1["SELECT_VERSION"] = false;
            Second_version1["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData2.Rows.Add(Second_version1);


            DataRow Third_Version1 = null;
            Third_Version1 = RecipeData2.NewRow();
            Third_Version1["CURRENT_RECIPE_VERSION"] = 3;
            Third_Version1["ENTITY/LINK"] = "A04_KWB403";
            Third_Version1["PARAMETER_DETAILS"] = table7;
            Third_Version1["SELECT_VERSION"] = false;
            Third_Version1["NEW_RECIPE_VERSION"] = System.DBNull.Value;
            RecipeData2.Rows.Add(Third_Version1);
            DataSet set = new DataSet("office");
            set.Tables.Add(RecipeData);
            set.Tables.Add(RecipeData2);

            Dataset = set;
          

         
          
           
        }
        

    
    

      



    }
}
